local Addon = _G[...]
local modName = ...
local title = "Digsite"

local widget = Addon:NewWidget(title, 'Frame')

widget.defaults = {
	basic = {
		position = {
			x = 0,
			y = -175,
			anchor = 'Center',
			frameLevel = 4,
			frameStrata = 2,
		},
	},
}

function widget:GetRestrictions()
	return "player", true
end

function widget:New(parent)	
	local bar = self:Bind(CreateFrame('Frame', nil, parent.box))
	bar:SetSize(10,10)
	
	
	bar.owner = parent	
	bar.owner = parent
	bar.title = title
	bar.handler = parent.id
	return bar
end

function widget:Update()
	local arch = ArcheologyDigsiteProgressBar
	if not arch then
		return
	else
		if not self.arch then
			ArcheologyDigsiteProgressBar:SetMovable(true)
			ArcheologyDigsiteProgressBar:SetUserPlaced(true);

			ArcheologyDigsiteProgressBar:ClearAllPoints()
			ArcheologyDigsiteProgressBar:SetParent(self)
			ArcheologyDigsiteProgressBar:SetPoint("Center", self)
			self.arch = true
		end
	end
	
	
	
end

function widget:Layout()


	self:Reposition()	
end


function widget:Reposition()
	local position = self.sets.basic.position
	local icon = self.sets.basic.icon
	
	self:ClearAllPoints()
	self:SetPoint(position.anchor, UIParent, position.x, position.y)
	
	local lay = Addon.layers[position.frameStrata]
	self:SetFrameStrata(lay)
	self:SetFrameLevel(position.frameLevel)	
end

widget.Options = {
	{
		name = "Basic",
		kind = "Panel",
		key = "basic",
		panel = "Basic",
		options = {
			{
				name = 'X Offset',
				kind = 'Slider',
				key = 'x',
				panel = 'position',
				min = -400,
				max = 400,
			},
			{
				name = 'Y Offset',
				kind = 'Slider',
				key = 'y',
				panel = 'position',
				min = -400,
				max = 400,
			},
			{
				name = 'Anchor',
				kind = 'Menu',
				key = 'anchor',
				panel = 'position',
				table = {
					'TopLeft',
					'Top',
					'TopRight',
					'Right',
					'BottomRight',
					'Bottom',
					'BottomLeft',
					'Left',
					'Center',
				},
			},
		{
			name = "Frame Level",
			kind = "Slider",
			key = "frameLevel",
			panel = 'position',
			min = 1,
			max = 100,
		},
		{
			name = "Frame Strata",
			kind = "Slider",
			key = "frameStrata",
			panel = 'position',
			min = 1,
			max = 8,
		},
			
		}
	},	
}